import sys
import os
import os.path
import datetime

FINE = 0
DEBUG = 1
INFO = 2
IMPORTANT = 3
WARNING = 4
ERROR = 5

#_log_lock = threading.Lock()
_log_new_line = True
_log_dir = os.path.join('./log')
_log_file_name = os.path.join(_log_dir,
                             datetime.datetime.now().strftime('%Y.%m.%d %H-%M-%S [' + str(os.getpid()) +'].log'))
_debug_level = IMPORTANT

def log(level, *msgs, **params):
    global _log_new_line
    message = '[' + datetime.datetime.now().strftime('%H:%M:%S') + ']: ' if _log_new_line else ''
    message += ' '.join(map(str,msgs))
    if _debug_level <= level:
            #with _log_lock:
        sys.stdout.write(message)
        sys.stdout.write(' ')
        if params.get('newline', True):
            sys.stdout.write('\n')
        sys.stdout.flush()

        if not os.path.exists(_log_dir):
            os.makedirs(_log_dir)

        try:
            f = open(_log_file_name, 'a')
            f.write(message)
            f.write(' ')
            _log_new_line = False
            if params.get('newline', True):
                f.write('\n')
                _log_new_line = True
            f.flush()
            f.close()
        except:
            sys.stdout.write('Problem logging into a file',sys.exc_info()[0])

def fine(*msgs, **params):
    log(FINE, *msgs, **params)

def debug(*msgs, **params):
    log(DEBUG, *msgs, **params)

def info(*msgs, **params):
    log(INFO, *msgs, **params)

def message(*msgs, **params):
    log(IMPORTANT, *msgs, **params)

def warning(*msgs, **params):
    log(WARNING, *msgs, **params)

def error(*msgs, **params):
    log(ERROR, *msgs, **params)

    sys.exit(-1)

def force(*msgs, **params):
    log(ERROR+1, *msgs, **params)

def progress(*msgs):
    message = ' '.join(map(str,msgs)) + '         \r'
    sys.stdout.write(message)
    sys.stdout.flush()


if __name__ != '__main__':
    message("STARTING on", datetime.datetime.now(), 'with pid =', os.getpid())
